<script lang="ts" setup>
import { defineProps, nextTick, ref } from 'vue'

import axios from 'axios'
import ApiDetailsCard from '@/views/chat/components/ApiDetailsCard.vue'

interface Message {
  role: 'system' | 'user'
  content: string
}

// Define la propiedad para recibir el contexto
const props = defineProps({
  context: {
    type: Array as () => Message[],
    default: () => [
      {
        role: 'system',
        content: 'Hola, soy ANA, tu asistente virtual. ¿En qué puedo ayudarte hoy?',
      },
    ],
  },
})

const messages = ref('')
const userInput = ref<string>('')
const loading = ref<boolean>(false)
const apiResponse = ref(null)

const openaiToken: string = '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' || ''
const localToken: string = 'Not needed for a local LLM' || ''

const openaiModel = 'gpt-3.5-turbo'
const localModel = 'gpt4all-j-v1.3-groovy'

const openaiClient = axios.create({
  baseURL: 'https://api.openai.com/v1/chat',
  headers: {
    'Authorization': `Bearer ${openaiToken}`,
    'Content-Type': 'application/json',
  },
})

const localClient = axios.create({
  baseURL: 'http://192.168.30.37/v1/chat',
  headers: {
    'Content-Type': 'application/json',
  },
})

interface OpenAIResponse {
  id: string
  object: string
  created: number
  model: string
  choices: {
    text: string
    index: number
    logprobs: any
    finish_reason: string
  }[]
}

const escapeHtml = (html: string) => {
  return html.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&#039;')
}

const formatMessage = (text: string) => {
  // Simplemente haces que el texto que identifiques como código se muestre en otro color, por ejemplo:
  return text.replace(/(`[^`]*`)/g, '<span style="color: green;">$1</span>')
}

const formattedMessages = computed(() => {
  return formatMessage(escapeHtml(messages.value))
})

interface OpenAIResponse {
  id: string
  object: string
  created: number
  model: string
  choices: {
    text: string
    index: number
    logprobs: any
    finish_reason: string
  }[]
}

const items = [
  { title: 'OpenAI GPT3.5-Turbo', value: 'openai', icon: 'tabler-brand-openai' },
  { title: 'MistralAI mistral-7b-instruct', value: 'local', icon: 'tabler-propeller' },
]

let selectedModel = openaiModel
let selectedClient = openaiClient

function selectModel(model) {
  if (model === 'openai') {
    selectedModel = openaiModel
    selectedClient = openaiClient
  }
  else {
    selectedModel = localModel
    selectedClient = localClient
  }
}

async function sendMessage(): Promise<void> {
  if (userInput.value.trim() === '')
    return
  loading.value = true

  const temp_input = userInput.value

  userInput.value = ''
  try {
    const response = await selectedClient.post<OpenAIResponse>('/completions', {
      model: selectedModel,
      messages: [
        ...props.context,
        {
          role: 'user',
          content: `Pregunta: ${temp_input}\nRespuesta:`,
        },
      ],
      max_tokens: 700,
      temperature: 0,
      top_p: 1,
      frequency_penalty: 0,
      presence_penalty: 0,
    }, {
      timeout: 120000, // Timeout set to 120,000 ms (2 minutes)
    })

    messages.value += `Pregunta: ${temp_input}\nRespuesta: ${response.data.choices[0].message.content}\n\n`

    console.log(response)
    apiResponse.value = response.data
    console.log(apiResponse.value)
  }
  catch (error: any) {
    console.error('Error al enviar el mensaje:', error)
    messages.value += `Error al enviar el mensaje: ${error.message}\n`
  }
  finally {
    loading.value = false
    await nextTick()
    scrollToBottom()
  }
}

const drawer = ref(false)

// Definición de la interfaz para los datos de las tarjetas
interface Card {
  title: string
  subtitle: string
  action: () => void
}

// Función para manejar el clic en una tarjeta
const handleCardClick = async (subtitle: string) => {
  userInput.value = subtitle
  await sendMessage()
}

// Datos de las tarjetas
const cards = ref<Card[]>([
  {
    icon: 'tabler-brand-python',
    title: 'Python Temperature',
    subtitle: 'Python script to get the temperature of a Powerage R600',
    action: async () => {
      await handleCardClick('Python script to get the temperature of a Powerage R600')
    },
  },
  {
    icon: 'tabler-brand-ansible',
    title: 'Ansible Helm charts',
    subtitle: 'Ansible playbook to deploy Grafana using helm charts',
    action: async () => {
      await handleCardClick('Ansible playbook to deploy Grafana using helm charts')
    },
  },
  {
    icon: 'tabler-brand-aws',
    title: 'Bash VM on AWS',
    subtitle: 'A bash script to deploy a VM on AWS',
    action: async () => {
      await handleCardClick('A bash script to deploy a VM on AWS')
    },
  },
  {
    icon: 'tabler-brand-gitlab',
    title: 'GitLab with CPU and Memory consumption',
    subtitle: 'A job in gitlab ci with a crontab to measure CPU and RAM consumption',
    action: async () => {
      await handleCardClick('A job in gitlab ci with a crontab to measure CPU and RAM consumption')
    },
  },
])

// Función para desplazar el área de texto hacia abajo
const scrollToBottom = () => {
  const textarea = document.querySelector('.message-box') as HTMLTextAreaElement
  if (textarea) {
    textarea.scrollTo({
      top: textarea.scrollHeight,
      behavior: 'smooth',
    })
  }
}
</script>

<template>
  <VContainer
    fluid
    class="pa-0 fill-height"
  >
    <VRow no-gutters>
      <VCol>
        <VCard
          tile
          flat
        >
          <VCardTitle class="d-flex justify-space-between align-center">
            <span>ANA AI Assistance</span>

            <VMenu>
              <template #activator="{ props }">
                <VBtn
                  color="primary"
                  v-bind="props"
                >
                  Models
                </VBtn>
              </template>
              <VList>
                <VListItem
                  v-for="item in items"
                  :key="item.value"
                  @click="selectModel(item.value)"
                >
                  <VListItemTitle>
                    <div class="d-flex align-center">
                      <VIcon
                        :class="item.icon"
                        class="mr-2"
                      />
                      {{ item.title }}
                    </div>
                  </VListItemTitle>
                </VListItem>
              </VList>
            </VMenu>

            <VBtn
              icon="tabler-menu-2"
              rounded
              size="x-small"
              variant="outlined"
              color="secondary"
              @click.stop="drawer = !drawer"
            />
          </VCardTitle>

          <VNavigationDrawer
            v-model="drawer"
            absolute
            temporary
            right
            touchless
            location="end"
            width="390"
          >
            <ApiDetailsCard
              :api-data="apiResponse"
              @close="drawer = false"
            />
          </VNavigationDrawer>

          <VCardText>
            <div
              class="message-box formatted-text-area"
              readonly
              auto-grow
              v-html="formattedMessages"
            />
          </VCardText>

          <VCardActions>
            <VTextField
              v-model="userInput"
              label="Escribe un mensaje"
              outlined
              dense
              variant="solo"
              class="flex-grow-1 mr-2"
              placeholder="Type your message..."
              density="default"
              autofocus
              @keyup.enter="sendMessage"
            >
              <template #append>
                <VBtn
                  :disabled="loading"
                  variant="outlined"
                  class="ma-0 pa-0"
                  x-small
                  style="height: 100%;"
                  @click="sendMessage"
                >
                  <VProgressCircular
                    v-if="loading"
                    indeterminate
                    size="24"
                    color="blue"
                  />
                  <span v-else>
                    <VIcon icon="tabler-send" />Send</span>
                </VBtn>
              </template>
            </VTextField>
          </VCardActions>
        </VCard>

        <br>

        <VRow style="margin-left: 32px; margin-right: 32px; padding-left: 32px; padding-right: 32px">
          <VCol
            v-for="card in cards"
            :key="card.title"
            cols="12"
            md="6"
            style="padding: 4px;"
          >
            <VCard
              class="v-card-default-question mx-auto"
              @click="card.action"
            >
              <VCardTitle style="font-size: medium">
                <VIcon
                  :icon="card.icon"
                  size="32"
                />
                {{ card.title }}
              </VCardTitle>
              <p
                class="subtitle"
                style="font-size: smaller; padding: 0.5rem 1rem;"
              >
                {{ card.subtitle }}
              </p>
            </VCard>
          </VCol>
        </VRow>
      </VCol>
    </VRow>
  </VContainer>
</template>

<style scoped>
.formatted-text-area {
  white-space: pre-wrap;
  background-color: #f5f5f5;
  border: 1px solid #ccc;
  padding: 8px;
  border-radius: 4px;
  overflow-y: auto;
  height: calc(75vh - 140px); /* Ajusta la altura para que reste el espacio de los inputs y título */
}

.v-card-default-question {
  cursor: pointer;
  transition: transform 0.2s;
}

.v-card-default-question:hover {
  transform: scale(1.10);
}

.message-box {
  overflow-y: auto;
}
</style>
